/*
 * IzPack - Copyright 2001-2008 Julien Ponge, All Rights Reserved.
 *
 * http://izpack.org/
 * http://izpack.codehaus.org/
 *
 * Copyright 2008 Patrick Zbinden.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.izforge.izpack.installer.manager;

import com.izforge.izpack.api.installer.DataValidator;

public final class DataValidatorFactory
{

    public static DataValidator createDataValidator(String className)
    {
        DataValidator validator = null;
        if (className != null)
        {

            try
            {
                validator = (DataValidator) Class.forName(className).newInstance();
                try
                {
                    // try fully qualified class name
                    validator = (DataValidator) Class.forName(className).newInstance();
                }
                catch (ClassNotFoundException e)
                {
                    validator = (DataValidator) Class.forName(
                            "com.izforge.izpack.installer.validator." + className).newInstance();
                }
            }
            catch (InstantiationException e)
            {
                e.printStackTrace();
            }
            catch (IllegalAccessException e)
            {
                e.printStackTrace();
            }
            catch (ClassNotFoundException e)
            {
                e.printStackTrace();
            }
        }
        return validator;

    }

}
